
#include <TinyGPS.h>

TinyGPS gps;

static void smartdelay(unsigned long ms);
static void print_float(float val, float invalid, int len, int prec);
static void print_int(unsigned long val, unsigned long invalid, int len);
static void print_date(TinyGPS &gps);
static void print_str(const char *str, int len);

void setup()
{
  Serial.begin(115200);
  
  Serial1.begin(9600);
}

void loop()
{
  float flat, flon;
  unsigned long age;

  Serial.print("satellites = ");
  int sats = gps.satellites();
  if (sats == TinyGPS::GPS_INVALID_SATELLITES) {
    Serial.println("-");  
  } else {
    Serial.println(sats); 
    if (sats >= 3) {
      gps.f_get_position(&flat, &flon, &age);
      Serial.print("Latitude (deg) = ");
      Serial.println(flat == float(TinyGPS::GPS_INVALID_F_ANGLE) ? 0 : flat, 6);
      Serial.print("Longitude (deg) = ");
      Serial.println(flon == float(TinyGPS::GPS_INVALID_F_ANGLE) ? 0 : flon, 6);     
    }
  }

  smartdelay(1000);
}

static void smartdelay(unsigned long ms)
{
  unsigned long start = millis();
  do 
  {
    while (Serial1.available())
      gps.encode(Serial1.read());
  } while (millis() - start < ms);
}

